unit Main;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Mask;

type
  TMainForm = class(TForm)
    CheckBoxGroupBox: TGroupBox;
    Bit1CheckBox:TCheckBox;
    Bit2CheckBox:TCheckBox;
    Bit3CheckBox:TCheckBox;
    Bit4CheckBox:TCheckBox;
    Bit5CheckBox:TCheckBox;
    Bit6CheckBox:TCheckBox;
    Bit7CheckBox:TCheckBox;
    Bit8CheckBox:TCheckBox;
    Bevel1: TBevel;
    ResultLabel: TLabel;
    decimalEdit: TEdit;
    procedure FormCreate(Sender: TObject);
    procedure BitCheckBoxClick(Sender: TObject);
    procedure decimalEditKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
  private
    Bits:array[1..8] of TCheckBox;
    procedure resetResult;
end;

var MainForm: TMainForm;

implementation

{$R *.DFM}

// diese Methode wird nur beim OnCreate-Ereignis (Erzeugen des Formulars, hier
// also beim Programmstart) ausgefhrt
procedure TMainForm.FormCreate(Sender: TObject);
begin
// CheckBox-Array fllen
  Bits[1]:=Bit1CheckBox;
  Bits[2]:=Bit2CheckBox;
  Bits[3]:=Bit3CheckBox;
  Bits[4]:=Bit4CheckBox;
  Bits[5]:=Bit5CheckBox;
  Bits[6]:=Bit6CheckBox;
  Bits[7]:=Bit7CheckBox;
  Bits[8]:=Bit8CheckBox;
end;

// Diese Methode wird beim OnClick-Ereignis jeder CheckBox ausgefhrt
// (im Objektinspektor wurde bei der Ereignismethode jedesmal dieselbe Methode
// eingetragen)
procedure TMainForm.BitCheckBoxClick(Sender: TObject);
var Lv,Value:Byte;
    Increment:Word;
begin
  Value:=0;
  Increment:=1;
// Schleife zum Auswerten der CheckBox-Zustnde
  for Lv:=8 downto 1 do begin
    if Bits[Lv].Checked then Inc(Value,Increment);
    Increment:=Increment*2;
  end;
// Ergebnis in decimalMaskEdit ausgeben
  decimalEdit.Text:=IntToStr(Value);
end;

// Hilfsmethode um das Ergebnis zurckzusetzen
procedure TMainForm.resetResult;
var lv:byte;
begin
  for lv:=1 to 8 do Bits[lv].Checked:=False;
  decimalEdit.Text:='0';
end;

// diese Prozedur wird beim OnKeyDown-Ereignis des decimalEdit auf gerufen
procedure TMainForm.decimalEditKeyDown(Sender: TObject; var Key: Word;
Shift: TShiftState);
var zahl,ablage,maxDigit,lv:byte;
begin
// Wenn die gedrckte Taste 'Enter', war dann ...
  if (Key=vk_Return) then begin
    try
// Wandle Eingabe in Byte
      zahl:=StrToInt(decimalEdit.Text);
      ablage:=zahl;
// Bestimme grte Binrstelle
      maxDigit:=9;
      while (ablage>0) do begin
        ablage:=ablage div 2;
        dec(maxDigit);
      end;
// Setze zuerst die fhrenden Nullen und danach die restlichen Binrstellen
// durch fortwhrendes Teilen durch zwei, ist der Rest ungleich Null
// ergibt sich fr die Binrstelle (es wird von hinten angefangen!)
// eine Null, sonst Eins
      for lv:=maxDigit-1 downto 1 do Bits[lv].Checked:=False;
      for lv:=8 downto maxDigit do begin
        Bits[lv].checked:=(zahl mod 2 > 0);
        zahl:=zahl div 2;
      end;
// Exceptions fr Bereichsverletzung und Fehler bei der Konvertierung
// String->Integer abfangen
    except
      on ERangeError do resetResult;
      on EConvertError do resetResult;
    end;
  end;
end;

end.
